Add release script, fix sed for MacOS
[policy/parent.git] / integration / src / release_scripts / mkdock.sh
1 #!/bin/bash
2
3 #
4 # ============LICENSE_START================================================
5 # ONAP
6 # =========================================================================
7 # Copyright (C) 2021 AT&T Intellectual Property. All rights reserved.
8 # Modifications Copyright (C) 2022 Nordix Foundation.
9 # =========================================================================
10 # Licensed under the Apache License, Version 2.0 (the "License");
11 # you may not use this file except in compliance with the License.
12 # You may obtain a copy of the License at
13 #
14 #      http://www.apache.org/licenses/LICENSE-2.0
15 #
16 # Unless required by applicable law or agreed to in writing, software
17 # distributed under the License is distributed on an "AS IS" BASIS,
18 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
19 # See the License for the specific language governing permissions and
20 # limitations under the License.
21 # ============LICENSE_END==================================================
22 #
23
24 #
25 # This creates the x.y.z-container.yaml file for releasing a docker image.
26 # It should be executed from somewhere within the "git" repo to be
27 # released.  Assumes the following:
28 #   - the latest commit is at the top of the "git log"
29 #   - the branch to be released is currently checked out
30 #   - the latest maven-docker-stage jenkins job is the one to be released
31 #   - the defaultbranch within the .gitreview file is set to the
32 #     branch to be released
33 #
34 # This uses xmllint, which is part of the libxml2-utils package.
35 #
36 # If behind a firewall, then http_proxy must be set so that curl
37 # can get through the firewall.
38 #
39
40 set -e
41
42 # Use the bash internal OSTYPE variable to check for MacOS
43 if [[ "$OSTYPE" == "darwin"* ]]
44 then
45     SED="gsed"
46 else
47     SED="sed"
48 fi
49
50 if [ $# -lt 1 -o "$1" = "-?" ]
51 then
52     echo "arg(s): docker-container-name1 docker-container-name2 ..." >&2
53     exit 1
54 fi
55
56 TOPDIR=$(git rev-parse --show-toplevel)
57 if [ -z "${TOPDIR}" ]; then
58     echo "cannot determine top of 'git' repo" >&2
59     exit 1
60 fi
61
62 BRANCH=$(awk -F= '$1 == "defaultbranch" { print $2 }' "${TOPDIR}/.gitreview")
63 if [ -z "${BRANCH}" ]; then
64     echo "cannot extract default branch from ${TOPDIR}/.gitreview" >&2
65     exit 1
66 fi
67 echo Branch: ${BRANCH}
68
69 PROJECT=$(awk -F= '$1 == "project" { print $2 }' "${TOPDIR}/.gitreview" |
70             $SED 's/.git$//')
71 if [ -z "${PROJECT}" ]; then
72     echo "cannot extract project from ${TOPDIR}/.gitreview" >&2
73     exit 1
74 fi
75 echo Project: ${PROJECT}
76 TPROJ=$(echo ${PROJECT} | $SED 's!/!%2F!')
77 DPROJ=$(echo ${PROJECT} | $SED 's!/!-!')
78
79 RELEASE=$(
80     xmllint --xpath \
81         '/*[local-name()="project"]/*[local-name()="version"]/text()' \
82         "${TOPDIR}/pom.xml" |
83     $SED 's!-SNAPSHOT!!'
84     )
85 if [ -z "${RELEASE}" ]; then
86     echo "cannot extract release from ${TOPDIR}/pom.xml" >&2
87     exit 1
88 fi
89 echo Release: ${RELEASE}
90
91 REF_ID=$(git log | grep commit | head -1 | awk '{ print $2 }')
92 if [ -z "${REF_ID}" ]; then
93     echo "cannot extract ref from 'git log'" >&2
94     exit 1
95 fi
96 echo Ref: ${REF_ID}
97
98 prefix='https://jenkins.onap.org/view/policy/job/'
99 STAGE_ID=$(
100     curl --silent ${prefix}${DPROJ}-maven-docker-stage-${BRANCH}/ |
101     grep "Last completed build" |
102     $SED -e 's!.*Last completed build .#!!' -e 's!).*!!' |
103     head -1
104     )
105 if [ -z "${STAGE_ID}" ]; then
106     echo "cannot extract last docker stage ID from jenkins" >&2
107     exit 1
108 fi
109 STAGE_ID=${DPROJ}-maven-docker-stage-${BRANCH}/${STAGE_ID}
110 echo Stage ID: ${STAGE_ID}
111
112 prefix='https://jenkins.onap.org/view/policy/job/'
113 JOB_OUT=$(curl --silent ${prefix}${STAGE_ID}/console)
114 echo "${JOB_OUT}" | grep -q "Finished: SUCCESS"
115 if [ $? -ne 0 ]; then
116     echo "last docker build has not completed successfully" >&2
117     exit 1
118 fi
119
120 echo Creating ${TOPDIR}/releases/${RELEASE}-container.yaml
121 cat >"${TOPDIR}/releases/${RELEASE}-container.yaml" <<EOT
122 distribution_type: 'container'
123 container_release_tag: '${RELEASE}'
124 project: '${DPROJ}'
125 log_dir: '${STAGE_ID}'
126 ref: ${REF_ID}
127 containers:
128 EOT
129
130 for CONT_NAME in "$@"
131 do
132     VERSION=$(
133         echo "${JOB_OUT}" |
134         awk "
135             /Successfully tagged onap/ { found = 0 }
136             /Successfully tagged onap\/${CONT_NAME}:/ { found = 1 }
137             found == 1 && /Tag with/ { print }
138         " |
139         head -1 |
140         $SED 's!.*Tag with!!' |
141         cut -d, -f2
142         )
143     if [ -z "${VERSION}" ]; then
144         echo "cannot extract ${CONT_NAME} version from jenkins build output" >&2
145         exit 1
146     fi
147     echo ${CONT_NAME} version: ${VERSION}
148
149     cat >>"${TOPDIR}/releases/${RELEASE}-container.yaml" <<EOT_LOOP
150     - name: '${CONT_NAME}'
151       version: '${VERSION}'
152 EOT_LOOP
153 done